package com.app.sounds.prank.party.act;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;

import com.app.sounds.prank.party.R;
import com.app.sounds.prank.party.common.Utils;
import com.app.sounds.prank.party.common.Manager;
import com.app.sounds.prank.party.databinding.RecordActivityBinding;
import com.app.sounds.prank.party.top.AdManager;

public class RecorderActivity extends AppCompatActivity {
  private RecordActivityBinding binding;
    private long startTime;
    private long elapsedTime;
    private Handler handler = new Handler();
    private Runnable runnable;
    private boolean isCreate = false;

    private Manager manager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = RecordActivityBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        Utils.setStatusBarTextColor(this, true);
        manager = new Manager(this);
        AdManager.loadAllAd();
        binding.audioTime.setText(R.string.time_init);

        initEvent();
    }

    private void initEvent() {
        binding.back.setOnClickListener(v -> finish());
        binding.imMic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                binding.imMic.setSelected(!binding.imMic.isSelected());
                createSound();
            }
        });
    }

    private void createSound() {
        if (!isCreate) {
            manager.startRecording();
            isCreate = true;
            runnable = new Runnable() {
                @SuppressLint("DefaultLocale")
                @Override
                public void run() {
                    long currentTime = SystemClock.elapsedRealtime();
                    elapsedTime = currentTime - startTime;
                    int milliseconds = (int) (elapsedTime % 1000) / 10;
                    int seconds = (int) (elapsedTime / 1000) % 60;
                    int minutes = (int) (elapsedTime / (1000 * 60)) % 60;
                    binding.audioTime.setText(String.format("%02d : %02d : %02d", minutes, seconds, milliseconds));
                    handler.postDelayed(this, 10);
                }
            };
            startTime = SystemClock.elapsedRealtime();
            handler.post(runnable);
        } else {
            manager.stopRecording();

            handler.removeCallbacks(runnable);
            Intent intent = new Intent(RecorderActivity.this, SaveActivity.class);
            intent.putExtra(SaveActivity.KEY_Time, elapsedTime);
            intent.putExtra(SaveActivity.KEY_Path, manager.getTempFileName());
            intent.putExtra(SaveActivity.KEY_import, 1);
            startActivity(intent);
            finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        handler.removeCallbacks(runnable);
    }
}